{ Copyright (C) 2014 Dimitar Paperov,Zdzislaw Dybikowski

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.

}
unit mdlib;

{$mode objfpc}{$H+}

interface
uses mdTypes;

type
  Tmd_new_app_id = function(aNewAppId: PMD_APP_ID): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_com_init = function(aComNumber:PChar; aBaudrate: integer): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_eth_init = function(aHost: PChar; aPort: integer): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_free = function: integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_logon = function(aParams: PMD_LOGON_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_logout = function(aParams: PMD_LOGON_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_stop_all_rotors = function(aParams: PMD_STOP_ALL_ROTORS_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_stop_rotor = function(aParams: PMD_STOP_ROTOR_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_get_config = function(aParams: PMD_CONFIG_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_get_rotor_config = function(aParams: PMD_ROTOR_CONFIG_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_get_rotor_angle = function(aParams: PMD_ROTOR_ANGLE_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_get_all_rotor_angles = function(aParams: PMD_ALL_ROTOR_ANGLES_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_set_config = function(aApp: PMD_APP_ID; aParams: PMD_CONFIG_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_set_rotor_config = function(aApp: PMD_APP_ID; aParams: PMD_ROTOR_CONFIG_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_set_rotor_angle = function(aApp: PMD_APP_ID; aParams: PMD_ROTOR_ANGLE_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};
  Tmd_set_all_rotor_angles = function(aApp: PMD_APP_ID; aParams: PMD_ALL_ROTOR_ANGLES_PARAMS): integer; {$IFDEF MSWINDOWS}stdcall{$ELSE}cdecl{$ENDIF};

var
  md_new_app_id: Tmd_new_app_id = nil;
  md_com_init: Tmd_com_init = nil;
  md_eth_init: Tmd_eth_init = nil;
  md_free: Tmd_free = nil;
  md_logon: Tmd_logon = nil;
  md_logout: Tmd_logout = nil;
  md_stop_all_rotors: Tmd_stop_all_rotors = nil;
  md_stop_rotor: Tmd_stop_rotor = nil;
  md_get_config: Tmd_get_config = nil;
  md_get_rotor_config: Tmd_get_rotor_config = nil;
  md_get_rotor_angle: Tmd_get_rotor_angle = nil;
  md_get_all_rotor_angles: Tmd_get_all_rotor_angles = nil;
  md_set_config: Tmd_set_config = nil;
  md_set_rotor_config: Tmd_set_rotor_config = nil;
  md_set_rotor_angle: Tmd_set_rotor_angle = nil;
  md_set_all_rotor_angles: Tmd_set_all_rotor_angles = nil;

function spidcomm_load(aDllName: string): boolean;
function spidcomm_free: boolean;

implementation
uses sysutils, dynlibs;

var hDLL: TLibHandle = 0;

function spidcomm_load(aDllName: string): boolean;
begin
  if hDLL = 0 then begin
    Result := false;
    if aDllName = '' then
    {$IFNDEF WINDOWS}
      aDllName := ExtractFilePath(ParamStr(0))+'libspidcomm.'+SharedSuffix;
    {$ELSE}
      aDllName := ExtractFilePath(ParamStr(0))+'spidcomm.'+SharedSuffix;
    {$ENDIF}
    hDLL := dynlibs.LoadLibrary(aDllName);
    if hDLL <> 0 then begin
      md_new_app_id           := Tmd_new_app_id(dynlibs.GetProcedureAddress(hDLL, 'md_new_app_id'));
      md_com_init             := Tmd_com_init(dynlibs.GetProcedureAddress(hDLL, 'md_com_init'));
      md_eth_init             := Tmd_eth_init(dynlibs.GetProcedureAddress(hDLL, 'md_eth_init'));
      md_free                 := Tmd_free(dynlibs.GetProcedureAddress(hDLL, 'md_free'));
      md_logon                := Tmd_logon(dynlibs.GetProcedureAddress(hDLL, 'md_logon'));
      md_logout               := Tmd_logout(dynlibs.GetProcedureAddress(hDLL, 'md_logout'));
      md_stop_all_rotors      := Tmd_stop_all_rotors(dynlibs.GetProcedureAddress(hDLL, 'md_stop_all_rotors'));
      md_stop_rotor           := Tmd_stop_rotor(dynlibs.GetProcedureAddress(hDLL, 'md_stop_rotor'));
      md_get_config           := Tmd_get_config(dynlibs.GetProcedureAddress(hDLL, 'md_get_config'));
      md_get_rotor_config     := Tmd_get_rotor_config(dynlibs.GetProcedureAddress(hDLL, 'md_get_rotor_config'));
      md_get_rotor_angle      := Tmd_get_rotor_angle(dynlibs.GetProcedureAddress(hDLL, 'md_get_rotor_angle'));
      md_get_all_rotor_angles := Tmd_get_all_rotor_angles(dynlibs.GetProcedureAddress(hDLL, 'md_get_all_rotor_angles'));
      md_set_config           := Tmd_set_config(dynlibs.GetProcedureAddress(hDLL, 'md_set_config'));
      md_set_rotor_config     := Tmd_set_rotor_config(dynlibs.GetProcedureAddress(hDLL, 'md_set_rotor_config'));
      md_set_rotor_angle      := Tmd_set_rotor_angle(dynlibs.GetProcedureAddress(hDLL, 'md_set_rotor_angle'));
      md_set_all_rotor_angles := Tmd_set_all_rotor_angles(dynlibs.GetProcedureAddress(hDLL, 'md_set_all_rotor_angles'));
      if
            Assigned(md_new_app_id)
        and Assigned(md_com_init)
        and Assigned(md_eth_init)
        and Assigned(md_free)
        and Assigned(md_logon)
        and Assigned(md_logout)
        and Assigned(md_stop_all_rotors)
        and Assigned(md_stop_rotor)
        and Assigned(md_get_config)
        and Assigned(md_get_rotor_config)
        and Assigned(md_get_rotor_angle)
        and Assigned(md_get_all_rotor_angles)
        and Assigned(md_set_config)
        and Assigned(md_set_rotor_config)
        and Assigned(md_set_rotor_angle)
        and Assigned(md_set_all_rotor_angles)
      then
        result := true
      else
        spidcomm_free;
    end;
  end else
    result := true;
end;
function spidcomm_free: boolean;
begin
  if Assigned(md_free) then
    md_free;
  if hDLL <> 0 then
    dynlibs.FreeLibrary(hDLL);
  hDLL := 0;
  md_new_app_id           := nil;
  md_com_init             := nil;
  md_eth_init             := nil;
  md_free                 := nil;
  md_logon                := nil;
  md_logout               := nil;
  md_stop_all_rotors      := nil;
  md_stop_rotor           := nil;
  md_get_config           := nil;
  md_get_rotor_config     := nil;
  md_get_rotor_angle      := nil;
  md_get_all_rotor_angles := nil;
  md_set_config           := nil;
  md_set_rotor_config     := nil;
  md_set_rotor_angle      := nil;
  md_set_all_rotor_angles := nil;
  Result := true;
end;

end.

