unit mdprottypes;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, mdTypes;

type
  { funciton structures }
  PMD_BEGIN = ^TMD_BEGIN;
  TMD_BEGIN = record
    dev: TMD_DEVICE_ID;
    cmd: word;
    len: word;
  end;

  { function md_stop_all_rotors }
  PMD_STOP_ALL_ROTORS_REQ = ^TMD_STOP_ALL_ROTORS_REQ;
  TMD_STOP_ALL_ROTORS_REQ = record
    rBegin: TMD_BEGIN;
    rApp: TMD_APP_ID;
    aEmpty: array [0..2] of byte;
    bXor: byte;
  end;
  PMD_STOP_ALL_ROTORS_ANS = ^TMD_STOP_ALL_ROTORS_ANS;
  TMD_STOP_ALL_ROTORS_ANS = record
    rBegin: TMD_BEGIN;
      wEmpty: word;
      bState: byte;
      bXor: byte;
  end;

  { function md_stop_rotor }
  PMD_STOP_ROTOR_REQ = ^TMD_STOP_ROTOR_REQ;
  TMD_STOP_ROTOR_REQ = record
    rBegin: TMD_BEGIN;
    rApp: TMD_APP_ID;
    wEmpty: word;
    bRotor: byte;
    bXor: byte;
  end;
  PMD_STOP_ROTOR_ANS = ^TMD_STOP_ROTOR_ANS;
  TMD_STOP_ROTOR_ANS = record
    rBegin: TMD_BEGIN;
    bEmpty: byte;
    bRotor: byte;
    bState: byte;
    bXor: byte;
  end;
  PMD_LOGON_REQ = ^TMD_LOGON_REQ;
  TMD_LOGON_REQ = record
    rBegin: TMD_BEGIN;
    rApp: TMD_APP_ID;
    aEmpty: array [0..2] of byte;
    bXor: byte;
  end;
  PMD_LOGON_ANS = ^TMD_LOGON_ANS;
  TMD_LOGON_ANS = record
    rBegin: TMD_BEGIN;
    wEmpty: word;
    bState: byte;
    bXor: byte;
  end;
  PMD_GET_CONFIG_REQ = ^TMD_GET_CONFIG_REQ;
  TMD_GET_CONFIG_REQ = record
    rBegin: TMD_BEGIN;
    aReserved: array [0..2] of byte;
    bXOR: byte;
  end;
  PMD_GET_CONFIG_ANS = ^TMD_GET_CONFIG_ANS;
  TMD_GET_CONFIG_ANS = record
    rBegin: TMD_BEGIN;
    rConfig: TMD_CONFIG;
    wReserved: word;
    bState: byte;
    bXOR: byte;
  end;
  PMD_SET_CONFIG_REQ = ^TMD_SET_CONFIG_REQ;
  TMD_SET_CONFIG_REQ = record
    rBegin: TMD_BEGIN;
    rApp: TMD_APP_ID;
    rConfig: TMD_CONFIG;
    bReserved: byte;
    bXOR: byte;
  end;
  PMD_SET_CONFIG_ANS = ^TMD_SET_CONFIG_ANS;
  TMD_SET_CONFIG_ANS = record
    rBegin: TMD_BEGIN;
    wReserved: word;
    bState: byte;
    bXOR: byte;
  end;
  PMD_GET_MOTOR_CONFIG_REQ = ^TMD_GET_MOTOR_CONFIG_REQ;
  TMD_GET_MOTOR_CONFIG_REQ = record
    rBegin: TMD_BEGIN;
    rotorIx: word;
    bReserved: byte;
    bXOR: byte;
  end;
  PMD_GET_MOTOR_CONFIG_ANS = ^TMD_GET_MOTOR_CONFIG_ANS;
  TMD_GET_MOTOR_CONFIG_ANS = record
    rBegin: TMD_BEGIN;
    rConfig: TMD_ROTOR_CONFIG;
    rotorIx: word;
    bState: byte;
    bXOR: byte;
  end;
  PMD_SET_MOTOR_CONFIG_REQ = ^TMD_SET_MOTOR_CONFIG_REQ;
  TMD_SET_MOTOR_CONFIG_REQ = record
    rBegin: TMD_BEGIN;
    rApp: TMD_APP_ID;
    rConfig: TMD_ROTOR_CONFIG;
    rotorIx: word;
    bReserved: byte;
    bXOR: byte;
  end;
  PMD_SET_MOTOR_CONFIG_ANS = ^TMD_SET_MOTOR_CONFIG_ANS;
  TMD_SET_MOTOR_CONFIG_ANS = record
    rBegin: TMD_BEGIN;
    rotorIx: word;
    bState: byte;
    bXOR: byte;
  end;
  PMD_GET_ROTOR_ANGLE_REQ = ^TMD_GET_ROTOR_ANGLE_REQ;
  TMD_GET_ROTOR_ANGLE_REQ = record
    rBegin: TMD_BEGIN;
    rotorIx: word;
    bReserved: byte;
    bXOR: byte;
  end;
  PMD_GET_ROTOR_ANGLE_ANS = ^TMD_GET_ROTOR_ANGLE_ANS;
  TMD_GET_ROTOR_ANGLE_ANS = record
    rBegin: TMD_BEGIN;
    angle: single;
    rotorIx: word;
    bState: byte;
    bXOR: byte;
  end;
  PMD_SET_ROTOR_ANGLE_REQ = ^TMD_SET_ROTOR_ANGLE_REQ;
  TMD_SET_ROTOR_ANGLE_REQ = record
    rBegin: TMD_BEGIN;
    rApp: TMD_APP_ID;
    angle: single;
    rotorIx: word;
    bCalibration: byte;
    bXOR: byte;
  end;
  PMD_SET_ROTOR_ANGLE_ANS = ^TMD_SET_ROTOR_ANGLE_ANS;
  TMD_SET_ROTOR_ANGLE_ANS = record
    rBegin: TMD_BEGIN;
    wReserved: word;
    bState: byte;
    bXOR: byte;
  end;
  PMD_GET_ROTORS_ANGLES_REQ = ^TMD_GET_ROTORS_ANGLES_REQ;
  TMD_GET_ROTORS_ANGLES_REQ = record
    rBegin: TMD_BEGIN;
    startMotorIx: word;
    bReserved: byte;
    bXOR: byte;
  end;
  PMD_GET_ROTORS_ANGLES_ANS = ^TMD_GET_ROTORS_ANGLES_ANS;
  TMD_GET_ROTORS_ANGLES_ANS = record
    rBegin: TMD_BEGIN;
    angles: array[0..1] of single;
    startMotorIx: word;
    bState: byte;
    bXOR: byte;
  end;
  PMD_SET_ROTORS_ANGLES_REQ = ^TMD_SET_ROTORS_ANGLES_REQ;
  TMD_SET_ROTORS_ANGLES_REQ = record
    rBegin: TMD_BEGIN;
    rApp: TMD_APP_ID;
    angles: array [0..1] of single;
    startMotorIx: word;
    bCalibration: byte;
    bXOR: byte;
  end;
  PMD_SET_ROTORS_ANGLES_ANS = ^TMD_SET_ROTORS_ANGLES_ANS;
  TMD_SET_ROTORS_ANGLES_ANS = record
    rBegin: TMD_BEGIN;
    wReserved: word;
    bState: byte;
    bXOR: byte;
  end;
  PMD_EL_MAP_REQ =  ^TMD_EL_MAP_REQ;
  TMD_EL_MAP_REQ = record
    rBegin: TMD_BEGIN;
    fromAngle: word;
    toAngle: word;
    aReserved: array[0..2] of byte;
    bXOR: byte;
  end;
  PMD_EL_MAP_ANS = ^TMD_EL_MAP_ANS;
  TMD_EL_MAP_ANS = record
    rBegin: TMD_BEGIN;
    fromAngle: word;
    toAngle: word;
    data: byte;
  end;

const
  { COMMANDS }
  MD_CMD_LOGIN              = 1;
  MD_CMD_LOGOUT             = 2;
  MD_CMD_GET_ROTOR_CONFIG   = 3;
  MD_CMD_SET_ROTOR_CONFIG   = 4;
  MD_CMD_GET_EL_MAP         = 5;
  MD_CMD_SET_EL_MAP         = 6;

  MD_CMD_GET_CONFIG         = 9;
  MD_CMD_SET_CONFIG         = 10;
  MD_CMD_GET_ROTOR_POS      = 11;
  MD_CMD_SET_ROTOR_POS      = 12;
  MD_CMD_GET_ALL_ROTOR_POS  = 13;
  MD_CMD_SET_ALL_ROTOR_POS  = 14;
  MD_CMD_STOP_ROTOR         = 15;
  MD_CMD_STOP_ALL_ROTORS    = 16;

  { DEVICE ERRORS }
  MD_DEV_NO_ERROR           = 0;
  MD_DEV_BUSY               = 1;
  MD_DEV_BAD_PARAMS         = 2;
  MD_DEV_XOR_ERROR          = 3;
  MD_DEV_CMD_NOT_SUPPORTED  = 4;
implementation

end.

