{ Copyright (C) 2014 Dimitar Paperov,Zdzislaw Dybikowski

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.
}


unit mdTypes;

interface

type
  { Common structures }
  PMD_DEVICE_ID = ^TMD_DEVICE_ID;
  TMD_DEVICE_ID = record
    group: word;
    number: word;
  end;
  PMD_APP_ID = ^TMD_APP_ID;
  TMD_APP_ID = record
    hiPart: cardinal;
    loPart: cardinal;
  end;
  PMD_ROTOR_CONFIG = ^TMD_ROTOR_CONFIG;
  TMD_ROTOR_CONFIG = record
    min_angle:    single;
    max_angle:    single;
    gear:         single;
    stop_at:      single;
    state:        byte;   // readonly
    m_type:       byte;
    kind:         byte;   // readonly
    input:        byte;
    start_time:   array [0..2] of byte;
    start_power:  array [0..2] of byte;
    stop_time:    array [0..2] of byte;
    stop_power:   array [0..2] of byte;
    max_power:    byte;
    puls_timeout: byte;
  end;
  PMD_CONFIG = ^TMD_CONFIG;
  TMD_CONFIG = record
    bTemplate: byte;
    bUseShortWay: byte;
    bUseElMap: byte;
    bConstElMap: byte;
    bMouseControl: byte;
    bMotorStart: byte;
    bMotorStop: byte;
    bShowAzimuth: byte;
    bControlM1: byte;
    bProtocolM1: byte;
    bControlM2: byte;
    bProtocolM2: byte;
    bPairRotors: byte;
  end;
  { function md_logon }
  { function md_logout }
  PMD_LOGON_PARAMS = ^TMD_LOGON_PARAMS;
  TMD_LOGON_PARAMS = record
    dev: TMD_DEVICE_ID;
    app: TMD_APP_ID;
  end;
  { function md_stop_all_rotors }
  PMD_STOP_ALL_ROTORS_PARAMS = ^TMD_STOP_ALL_ROTORS_PARAMS;
  TMD_STOP_ALL_ROTORS_PARAMS = record
    dev: TMD_DEVICE_ID;
    app: TMD_APP_ID;
  end;
  { function md_stop_rotor }
  PMD_STOP_ROTOR_PARAMS = ^TMD_STOP_ROTOR_PARAMS;
  TMD_STOP_ROTOR_PARAMS = record
    dev: TMD_DEVICE_ID;
    app: TMD_APP_ID;
    rotor: integer;
  end;
  { function md_get_config }
  { function md_set_config }
  PMD_CONFIG_PARAMS = ^TMD_CONFIG_PARAMS;
  TMD_CONFIG_PARAMS = record
    dev: TMD_DEVICE_ID;
    config: PMD_CONFIG;
  end;
  { function md_get_rotor_config }
  { function md_set_rotor_config }
  PMD_ROTOR_CONFIG_PARAMS = ^TMD_ROTOR_CONFIG_PARAMS;
  TMD_ROTOR_CONFIG_PARAMS = record
    dev: TMD_DEVICE_ID;
    rotorIx: integer;
    config: PMD_ROTOR_CONFIG;
  end;
  { function md_get_rotor_angle }
  { function md_set_rotor_angle }
  PMD_ROTOR_ANGLE_PARAMS = ^TMD_ROTOR_ANGLE_PARAMS;
  TMD_ROTOR_ANGLE_PARAMS = record
    dev: TMD_DEVICE_ID;
    rotorIx: integer;
    angle: single;
    calibration: byte;
  end;
  { function md_get_all_rotor_angles }
  { function md_set_all_rotor_angles }
  PMD_ALL_ROTOR_ANGLES_PARAMS = ^TMD_ALL_ROTOR_ANGLES_PARAMS;
  TMD_ALL_ROTOR_ANGLES_PARAMS = record
    dev: TMD_DEVICE_ID;
    startMotorIx: integer;
    angles: array[0..1] of single;
    calibration: integer;
  end;
  { function md_get_el_map }
  { function md_set_el_map }
  PMD_EL_MAP_PARAMS = ^TMD_EL_MAP_PARAMS;
  TMD_EL_MAP_PARAMS = record
    dev: TMD_DEVICE_ID;
    pElMap: pointer;     // pointer to array [0..359] of shortint;
    fromAngle: word; // 0..359
    toAngle: word; // fromAngle..359
  end;

const
  { ERRORS }
  MD_NO_ERROR                 = 0;
  MD_BAD_PARAMETERS           = 1;
  MD_COM_PORT_NOT_OPENED      = 2;
  MD_DATA_SEND_ERROR          = 3;
  MD_DATA_RECV_ERROR          = 4;
  MD_HOST_NOT_EXISTS          = 5;
  MD_NOT_READY                = 6;
  MD_BAD_RESPONSE_FROM_DEVICE = 7;
  MD_DEVICE_BUSY              = 8;
  MD_COMMAND_NOT_SUPPRTED     = 9;
  MD_UNEXPECTED_ERROR         = -1;
implementation

end.

