{
 Copyright (C) 2013 Dimitar Paperov

  This source is free software; you can redistribute it and/or modify it under
  the terms of the GNU General Public License as published by the Free
  Software Foundation; either version 2 of the License, or (at your option)
  any later version.

  This code is distributed in the hope that it will be useful, but WITHOUT ANY
  WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
  FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more
  details.

  A copy of the GNU General Public License is available on the World Wide Web
  at <http://www.gnu.org/copyleft/gpl.html>. You can also obtain it by writing
  to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
  MA 02111-1307, USA.

}
unit motor_config_form;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  ExtCtrls, mdTypes;

type

  { TForm3 }

  TForm3 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    cbxTemplate: TComboBox;
    cbxControl1: TComboBox;
    cbxProtocol1: TComboBox;
    cbxControl2: TComboBox;
    cbxProtocol2: TComboBox;
    GroupBox1: TGroupBox;
    gControl1: TGroupBox;
    gProtocol1: TGroupBox;
    gControl2: TGroupBox;
    gProtocol2: TGroupBox;
    UseShortWay: TRadioGroup;
    UseElevationMap: TRadioGroup;
    ConstElevationMap: TRadioGroup;
    MouseControl: TRadioGroup;
    StartRotor: TRadioGroup;
    StopRotor: TRadioGroup;
    ShowAzimuth: TRadioGroup;
    PairRotors: TRadioGroup;
    procedure cbxTemplateChange(Sender: TObject);
    procedure UseShortWayClick(Sender: TObject);
  private
    { private declarations }
    procedure SetEnable(aEnabled: boolean);
  public
    { public declarations }
    function ShowMe(aBtnCancelVisible: boolean): boolean;
    procedure ToInterface(var c: TMD_CONFIG);
    procedure FromInterface(var c: TMD_CONFIG);
  end;

var
  Form3: TForm3;

implementation

{$R *.lfm}

{ TForm3 }

procedure TForm3.UseShortWayClick(Sender: TObject);
begin
  gControl2.Enabled:=(cbxTemplate.ItemIndex>3) and (PairRotors.ItemIndex=0);
  gProtocol2.Enabled:=(cbxTemplate.ItemIndex>3) and (PairRotors.ItemIndex=0);
end;

procedure TForm3.SetEnable(aEnabled: boolean);
var i: integer;
begin
  for i:=0 to ControlCount - 1 do begin
    Controls[i].Enabled:=aEnabled;
  end;
end;

function TForm3.ShowMe(aBtnCancelVisible: boolean): boolean;
begin
  Button2.Visible:=aBtnCancelVisible;
  if aBtnCancelVisible then begin
    Button1.ModalResult:=mrOk;
    SetEnable(true);
    cbxTemplateChange(nil);
  end else begin
    SetEnable(false);
    Button1.ModalResult:=mrCancel;
    Button1.Enabled:=true;
  end;
  Result := (ShowModal = mrOk);
end;

procedure TForm3.ToInterface(var c: TMD_CONFIG);
begin
  cbxTemplate.ItemIndex:=c.bTemplate;
  UseShortWay.ItemIndex:=c.bUseShortWay;
  UseElevationMap.ItemIndex:=c.bUseElMap;
  ConstElevationMap.ItemIndex:=c.bConstElMap;
  MouseControl.ItemIndex:=c.bMouseControl;
  cbxProtocol1.ItemIndex:=c.bProtocolM1;
  cbxProtocol2.ItemIndex:=c.bProtocolM2;
  cbxControl1.ItemIndex:=c.bControlM1;
  cbxControl2.ItemIndex:=c.bControlM2;
  ShowAzimuth.ItemIndex:=c.bShowAzimuth;
  StartRotor.ItemIndex:=c.bMotorStart;
  StopRotor.ItemIndex:=c.bMotorStop;
  PairRotors.ItemIndex:=c.bPairRotors;
end;

procedure TForm3.FromInterface(var c: TMD_CONFIG);
begin
  c.bTemplate:=cbxTemplate.ItemIndex;
  c.bUseShortWay:=UseShortWay.ItemIndex;
  c.bUseElMap:=UseElevationMap.ItemIndex;
  c.bConstElMap:=ConstElevationMap.ItemIndex;
  c.bMouseControl:=MouseControl.ItemIndex;
  c.bProtocolM1:=cbxProtocol1.ItemIndex;
  c.bProtocolM2:=cbxProtocol2.ItemIndex;
  c.bControlM1:=cbxControl1.ItemIndex;
  c.bControlM2:=cbxControl2.ItemIndex;
  c.bShowAzimuth:=ShowAzimuth.ItemIndex;
  c.bMotorStart:=StartRotor.ItemIndex;
  c.bMotorStop:=StopRotor.ItemIndex;
  c.bPairRotors:=PairRotors.ItemIndex;
end;

procedure TForm3.cbxTemplateChange(Sender: TObject);
begin
  case cbxTemplate.ItemIndex of
    0: begin
      gControl1.Enabled:=false;
      gProtocol1.Enabled:=false;
      gControl2.Enabled:=false;
      gProtocol2.Enabled:=false;
      cbxControl1.ItemIndex:=0;
      cbxProtocol1.ItemIndex:=0;
      cbxControl2.ItemIndex:=0;
      cbxProtocol2.ItemIndex:=0;
      PairRotors.Enabled:=false;
      PairRotors.ItemIndex:=0;
    end;
    1: begin
      gControl1.Enabled:=true;
      gProtocol1.Enabled:=true;
      gControl2.Enabled:=false;
      gProtocol2.Enabled:=false;
      cbxControl2.ItemIndex:=0;
      cbxProtocol2.ItemIndex:=0;
      PairRotors.Enabled:=false;
      PairRotors.ItemIndex:=0;
    end;
    2: begin
      gControl1.Enabled:=true;
      gProtocol1.Enabled:=true;
      gControl2.Enabled:=false;
      gProtocol2.Enabled:=false;
      cbxControl2.ItemIndex:=0;
      cbxProtocol2.ItemIndex:=0;
      PairRotors.Enabled:=false;
      PairRotors.ItemIndex:=0;
    end;
    3: begin
      gControl1.Enabled:=true;
      gProtocol1.Enabled:=true;
      gControl2.Enabled:=false;
      gProtocol2.Enabled:=false;
      cbxControl2.ItemIndex:=0;
      cbxProtocol2.ItemIndex:=0;
      PairRotors.Enabled:=false;
      PairRotors.ItemIndex:=0;
    end;
    4: begin
      gControl1.Enabled:=true;
      gProtocol1.Enabled:=true;
      gControl2.Enabled:=PairRotors.ItemIndex=0;
      gProtocol2.Enabled:=PairRotors.ItemIndex=0;
      PairRotors.Enabled:=true;
    end;
  end;
end;

end.

